unit DlgPictureStyle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, CamDefines;

var gMonochromeFilterText : array[low(MonochromeFilterType)..high(MonochromeFilterType)] of string =
  ('None', 'Yellow', 'Orange', 'Red', 'Green');

var gMonochromeToneText : array[low(MonochromeToneType)..high(MonochromeToneType)] of string =
  ('None', 'Sepia', 'Blue', 'Violet', 'Green');

type
  TFormPictureStyle = class(TForm)
    LabelContrast: TLabel;
    LabelSharpness: TLabel;
    LabelSaturation: TLabel;
    LabelColorTone: TLabel;
    GroupBoxMonochrome: TGroupBox;
    CheckBoxMonochrome: TCheckBox;
    LabelMonochromeFilter: TLabel;
    LabelMonochromeTone: TLabel;
    SpinEditContrast: TSpinEdit;
    SpinEditSharpness: TSpinEdit;
    SpinEditSaturation: TSpinEdit;
    SpinEditColorTone: TSpinEdit;
    ComboBoxMonochromeTone: TComboBox;
    ComboBoxMonochromeFilter: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxMonochromeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPictureStyle: TFormPictureStyle;

implementation

{$R *.dfm}

procedure TFormPictureStyle.FormCreate(Sender: TObject);
var picture_style         : PictureStyleType;
    monochrome_filter_cnt : MonochromeFilterType;
    monochrome_tone_cnt   : MonochromeToneType;
begin
  picture_style.PictureStyleEnabled := false; //To get rid of "picture_style not used" compiler warning
  SpinEditContrast.MinValue   := low(picture_style.Contrast);
  SpinEditContrast.MaxValue   := high(picture_style.Contrast);
  SpinEditContrast.Value      := 0;
  SpinEditSharpness.MinValue  := low(picture_style.Sharpness);
  SpinEditSharpness.MaxValue  := high(picture_style.Sharpness);
  SpinEditSharpness.Value     := 0;
  SpinEditSaturation.MinValue := low(picture_style.Saturation);
  SpinEditSaturation.MaxValue := high(picture_style.Saturation);
  SpinEditSaturation.Value    := 0;
  SpinEditColorTone.MinValue  := low(picture_style.ColorTone);
  SpinEditColorTone.MaxValue  := high(picture_style.ColorTone);
  SpinEditColorTone.Value     := 0;
  ComboBoxMonochromeFilter.Items.Clear;
  for monochrome_filter_cnt := low(monochrome_filter_cnt) to high(monochrome_filter_cnt) do
  begin
    ComboBoxMonochromeFilter.Items.Add(gMonochromeFilterText[monochrome_filter_cnt]);
  end;
  ComboBoxMonochromeTone.Items.Clear;
  for monochrome_tone_cnt := low(monochrome_tone_cnt) to high(monochrome_tone_cnt) do
  begin
    ComboBoxMonochromeTone.Items.Add(gMonochromeToneText[monochrome_tone_cnt]);
  end;
  CheckBoxMonochromeClick(Sender);
end;

procedure TFormPictureStyle.CheckBoxMonochromeClick(Sender: TObject);
begin
  ComboBoxMonochromeFilter.Enabled := CheckBoxMonochrome.Checked;
  ComboBoxMonochromeTone.Enabled   := CheckBoxMonochrome.Checked;
  SpinEditSaturation.Enabled       := not CheckBoxMonochrome.Checked;
  SpinEditColorTone.Enabled        := not CheckBoxMonochrome.Checked;
end;

end.
